<template>
  <div class="form-control">
    <VInput
      :type="type"
      :invalid="!isValid"
      :label="label"
      v-model="controlValue"
      @change="onChange"
      @focusout="onFocusOut"
    />
    <ul
      v-if="!isValid"
      class="form-error__group"
      :class="{ invalid: !isValid }"
    >
      <li
        v-for="(error, index) in control.errors"
        :key="index"
        class="form-error__item"
        v-text="error"
      ></li>
    </ul>
  </div>
</template>

<script>
import VInput from "@/components/VInput";

export default {
  name: "VControl",
  components: { VInput },
  props: {
    type: {
      type: String,
      default: "text"
    },
    control: {
      type: Object,
      default: () => ({
        value: "",
        errors: []
      })
    },
    label: {
      type: String,
      default: ""
    }
  },
  computed: {
    controlValue: {
      get() {
        return this.control.value;
      },
      set(value) {
        this.$emit("input", value);
        this.control.touched && this.control.validate();
      }
    },
    isValid() {
      return !this.control.errors.length;
    }
  },
  methods: {
    onChange() {
      this.$emit("change", this.controlValue);
    },
    onFocusOut() {
      this.control.validate();
      this.control.setTouchStatus(true);
      this.$emit("focusout", this.controlValue);
    }
  }
};
</script>

<style scoped lang="scss">
@function map-fetch($map, $keys...) {
  @each $key in $keys {
    $map: map-get($map, $key);
  }
  @return $map;
}
$z-index: (
  blur: 0,
  body: 1,
  header: 2,
  arrow: 2
);
$colors: (
  hero-bg: rgba(white, 0.7),
  body-bg: rgba(#f7f7f7, 0.6),
  arrow-bg: darken(white, 15%),
  error: red,
  text: #303030
);
$shadows: (
  card: 8px 10px 0px 1px rgba(0, 0, 0, 0.4)
);
$config: (
  bg-image: "https://lorempixel.com/1200/1200/nature/3",
  z-index: $z-index,
  colors: $colors,
  shadows: $shadows
);

.invalid {
  color: map-fetch($config, colors, red);
  background: map-fetch($config, bg-image);
}
</style>
